CLS

' ***** Scale car up or down *****
'                               Strava 09/26/2002

'CARS.CAR data format
'
'datatypes used
'
'byte:    1 byte, unsigned integer
'word:    2 bytes, unsigned integer
'dword:   4 bytes, unsigned integer
'float:   4 bytes, floating point number
'vec3:    12 bytes, 3 floats (x, y, z) or (w, h, l)
'sz[n]:   n bytes, zero terminated string
'
'offset   datatype       description
'
'----- header -----
'0        dword          size in bytes of one car (currently 1344)
addr.size = 1
DIM size AS LONG
'4        dword          number of cars
addr.numcars = 5
DIM numcars AS LONG
'
'----- for each car (real_offset = offset + 8 + carsize + carnum) -----
'0        sz[13]         name
addr.carname = 9
DIM carname AS STRING * 13
'13       byte[3]        unused
'16       vec3           size of the car                 
addr.carsize = 25
DIM carsize(2) AS SINGLE
'28       float[4]       array of tyre sizes (RF, LF, RR, LR)
addr.tiresize = 37
DIM tiresize(3) AS SINGLE
'44       14*float       grip values (see table) (0.1 .. 3.0)
addr.grip = 53
DIM grip(13) AS SINGLE
'100      14*float       slowdown values (0.0 .. 2.0)
addr.slow = 109
DIM slow(13) AS SINGLE
'156      float          air resistance (0..20)
addr.air = 165
DIM air AS SINGLE
'160      float          wings (0..200)
addr.wing = 169
DIM wing AS SINGLE
'164      float          power (50..1500) hp
addr.power = 173
DIM power AS SINGLE
'168      float          top speed (50..300) m/s
addr.speed = 177
DIM speed AS SINGLE
'172      float          sliding (0..2)
addr.slide = 181
DIM slide AS SINGLE
'176      float          mass (100..2000) kg
addr.mass = 185
DIM mass AS SINGLE
'180      float          balance (0.5 .. 2.0)
addr.balance = 189
DIM balance AS SINGLE
'184      float          AI value (0..10) (generally slippy car needs a lower value)
addr.ai = 193
DIM ai AS SINGLE
'188      byte           number of vertices
addr.numvert = 197
DIM numvert AS STRING * 1
'189      byte           number of vertices (shadow)
addr.numvertshad = 198
DIM numvertshad AS STRING * 1
'190      byte           number of indices
addr.numindx = 199
DIM numindx AS STRING * 1
'191      byte           number of indices (shadow)
addr.numindxshad = 200
DIM numindxshad AS STRING * 1
'192      byte           helmet (0=visible)
addr.helmetvisi = 201
DIM helmetvisi AS STRING * 1
'193      byte[120]      array of indices tri1=(i[0], i[1], i[2]), tri1=(i[3], i[4], i[5]), and so on.
addr.indx = 202
DIM indx(39, 2) AS STRING * 1
'313      byte[40]       array of triangle colors
addr.colorbits = 322
DIM colorbits(39) AS STRING * 1
'353      byte[30]       array of indices (shadow)
addr.indxshad = 362
DIM indxshad(9, 2) AS STRING * 1
'383      byte           unused
'384      vec3[30]       array of vertices
addr.vert = 393
DIM vert(29, 2) AS SINGLE
'744      vec3[30]       array of normals
addr.normal = 753
DIM normal(29, 2) AS SINGLE
'1104     vec3[15]       array of vertices (shadow)
addr.vertshad = 1113
DIM vertshad(14, 2) AS SINGLE
'1284     vec3[4]        array of tyre positions (RF, LF, RR, LR)
addr.tire = 1293
DIM tire(3, 2) AS SINGLE
'1332     vec3           helmet position
addr.helmet = 1341
DIM helmet(2) AS SINGLE

DIM surface(13) AS STRING
surface(0) = "oil"
surface(1) = "tarmac"
surface(2) = "tarmac2"
surface(3) = "grass"
surface(4) = "mud"
surface(5) = "gravel"
surface(6) = "gravel2"
surface(7) = "sand"
surface(8) = "sand2"
surface(9) = "snow"
surface(10) = "ice"
surface(11) = "kerb"
surface(12) = "kerb2"
surface(13) = "loose gravel"

DIM scale AS SINGLE

'************  end of data definitions ********************
INPUT "Name of Car File? ", f$
OPEN f$ FOR BINARY AS #1
INPUT "Scale Factor? ", scale
GET #1, addr.size, size
PRINT "size", size
GET #1, addr.numcars, numcars
PRINT "numcars", numcars
GET #1, addr.carname, carname
PRINT "carname", carname
FOR i = 0 TO 2
        GET #1, addr.carsize + i * 4, carsize(i)
        carsize(i) = carsize(i) * scale
        PUT #1, addr.carsize + i * 4, carsize(i)
        PRINT "carsize"; i, carsize(i)
NEXT
FOR i = 0 TO 3
        GET #1, addr.tiresize + i * 4, tiresize(i)
        tiresize(i) = tiresize(i) * scale
        PUT #1, addr.tiresize + i * 4, tiresize(i)
        PRINT "tirsize"; i, tiresize(i)
NEXT
INPUT "continue", r$
CLS
FOR i = 0 TO 13
        GET #1, addr.grip + i * 4, grip(i)
        'PRINT surface(i), grip(i)
NEXT
'INPUT "continue", r$
'CLS
FOR i = 0 TO 13
        GET #1, addr.slow + i * 4, slow(i)
        'PRINT surface(i), slow(i)
NEXT
'INPUT "continue", r$
'CLS
GET #1, addr.air, air
'PRINT "air", air
GET #1, addr.wing, wing
'PRINT "wing", wing
GET #1, addr.power, power
'PRINT "power", power
GET #1, addr.speed, speed
'PRINT "speed", speed
GET #1, addr.slide, slide
'PRINT "slide", slide
GET #1, addr.mass, mass
'PRINT "mass", mass
GET #1, addr.balance, balance
'PRINT "balance", balance
GET #1, addr.ai, ai
'PRINT "ai", ai
GET #1, addr.numvert, numvert
'PRINT "numvert", ASC(numvert)
GET #1, addr.numvertshad, numvertshad
'PRINT "numvertshad", ASC(numvertshad)
GET #1, addr.numindx, numindx
'PRINT "numindx", ASC(numindx), "num polys", ASC(numindx) / 3
GET #1, addr.numindxshad, numindxshad
'PRINT "numindxshad", ASC(numindxshad), "num polys", ASC(numindxshad) / 3
GET #1, addr.helmetvisi, helmetvisi
'PRINT "helmetvisi", ASC(helmetvisi)
'INPUT "continue", r$
'CLS
FOR i = 0 TO ASC(numindx) / 3 - 1
        FOR j = 0 TO 2
                GET #1, addr.indx + j + i * 3, indx(i, j)
        NEXT
        'PRINT "indx"; i, ASC(indx(i, 0)); ASC(indx(i, 1)); ASC(indx(i, 2))
        'IF (i + 1) / 10 = (i + 1) \ 10 THEN
        '        INPUT "continue", r$
        '        CLS
        'END IF
NEXT
'INPUT "continue", r$
'CLS
FOR i = 0 TO ASC(numindx) / 3 - 1
        GET #1, addr.colorbits + i, colorbits(i)
        'PRINT "colorbits"; i, ASC(colorbits(i))
        'IF (i + 1) / 10 = (i + 1) \ 10 THEN
        '        INPUT "continue", r$
        '        CLS
        'END IF
NEXT
'INPUT "continue", r$
'CLS
FOR i = 0 TO ASC(numindxshad) / 3 - 1
        FOR j = 0 TO 2
                GET #1, addr.indxshad + j + i * 3, indxshad(i, j)
        NEXT
        'PRINT "indxshad"; i, ASC(indxshad(i, 0)); ASC(indxshad(i, 1)); ASC(indxshad(i, 2))
        'IF (i + 1) / 10 = (i + 1) \ 10 THEN
        '        INPUT "continue", r$
        '        CLS
        'END IF
NEXT
'INPUT "continue", r$
'CLS
FOR i = 0 TO ASC(numvert) - 1
        FOR j = 0 TO 2
                GET #1, addr.vert + j * 4 + i * 12, vert(i, j)
                vert(i, j) = vert(i, j) * scale
                PUT #1, addr.vert + j * 4 + i * 12, vert(i, j)
        NEXT
        PRINT "vert"; i, vert(i, 0), vert(i, 1), vert(i, 2)
        IF (i + 1) / 10 = (i + 1) \ 10 THEN
                INPUT "continue", r$
                CLS
        END IF
NEXT
INPUT "continue", r$
CLS
FOR i = 0 TO ASC(numvert) - 1
        FOR j = 0 TO 2
                GET #1, addr.normal + j * 4 + i * 12, normal(i, j)
        NEXT
        'PRINT "normal"; i, normal(i, 0), normal(i, 1), normal(i, 2)
        'IF (i + 1) / 10 = (i + 1) \ 10 THEN
        '        INPUT "continue", r$
        '        CLS
        'END IF
NEXT
'INPUT "continue", r$
'CLS
FOR i = 0 TO ASC(numvertshad) - 1
        FOR j = 0 TO 2
                GET #1, addr.vertshad + j * 4 + i * 12, vertshad(i, j)
                vertshad(i, j) = vert(i, j) * scale
                PUT #1, addr.vertshad + j * 4 + i * 12, vertshad(i, j)
        NEXT
        PRINT "vertshad"; i, vertshad(i, 0), vertshad(i, 1), vertshad(i, 2)
        IF (i + 1) / 10 = (i + 1) \ 10 THEN
                INPUT "continue", r$
                CLS
        END IF
NEXT
'INPUT "continue", r$
'CLS
FOR i = 0 TO 3
        FOR j = 0 TO 2
                GET #1, addr.tire + j * 4 + i * 12, tire(i, j)
                tire(i, j) = tire(i, j) * scale
                PUT #1, addr.tire + j * 4 + i * 12, tire(i, j)
        NEXT
        PRINT "tire"; i, tire(i, 0), tire(i, 1), tire(i, 2)
NEXT
FOR i = 0 TO 2
        GET #1, addr.helmet + i * 4, helmet(i)
        helmet(i) = helmet(i) * scale
        PUT #1, addr.helmet + i * 4, helmet(i)
        PRINT "helmet"; i, helmet(i)
NEXT
CLOSE

SYSTEM

