DECLARE SUB poly ()
DECLARE SUB vertex ()

CLS

' ***** Read shadow 3DO and write verts & polys *****
'                              Strava 09/26/2002

'CARS.CAR data format
'
'datatypes used
'
'byte:    1 byte, unsigned integer
'word:    2 bytes, unsigned integer
'dword:   4 bytes, unsigned integer
'float:   4 bytes, floating point number
'vec3:    12 bytes, 3 floats (x, y, z) or (w, h, l)
'sz[n]:   n bytes, zero terminated string
'
'offset   datatype       description
'
'----- header -----
'0        dword          size in bytes of one car (currently 1344)
addr.size = 1
DIM size AS LONG
'4        dword          number of cars
addr.numcars = 5
DIM numcars AS LONG
'
'----- for each car (real_offset = offset + 8 + carsize + carnum) -----
'0        sz[13]         name
addr.carname = 9
DIM carname AS STRING * 13
'13       byte[3]        unused
'16       vec3           size of the car       
addr.carsize = 25
DIM carsize(2) AS SINGLE
'28       float[4]       array of tyre sizes (RF, LF, RR, LR)
addr.tiresize = 37
DIM tiresize(3) AS SINGLE
'44       14*float       grip values (see table) (0.1 .. 3.0)
addr.grip = 53
DIM grip(13) AS SINGLE
'100      14*float       slowdown values (0.0 .. 2.0)
addr.slow = 109
DIM slow(13) AS SINGLE
'156      float          air resistance (0..20)
addr.air = 165
DIM air AS SINGLE
'160      float          wings (0..200)
addr.wing = 169
DIM wing AS SINGLE
'164      float          power (50..1500) hp
addr.power = 173
DIM power AS SINGLE
'168      float          top speed (50..300) m/s
addr.speed = 177
DIM speed AS SINGLE
'172      float          sliding (0..2)
addr.slide = 181
DIM slide AS SINGLE
'176      float          mass (100..2000) kg
addr.mass = 185
DIM mass AS SINGLE
'180      float          balance (0.5 .. 2.0)
addr.balance = 189
DIM balance AS SINGLE
'184      float          AI value (0..10) (generally slippy car needs a lower value)
addr.ai = 193
DIM ai AS SINGLE
'188      byte           number of vertices
addr.numvert = 197
DIM numvert AS STRING * 1
'189      byte           number of vertices (shadow)
addr.numvertshad = 198
DIM numvertshad AS STRING * 1
'190      byte           number of indices
addr.numindx = 199
DIM numindx AS STRING * 1
'191      byte           number of indices (shadow)
addr.numindxshad = 200
DIM numindxshad AS STRING * 1
'192      byte           helmet (0=visible)
addr.helmetvisi = 201
DIM helmetvisi AS STRING * 1
'193      byte[120]      array of indices tri1=(i[0], i[1], i[2]), tri1=(i[3], i[4], i[5]), and so on.
addr.indx = 202
DIM indx(39, 2) AS STRING * 1
'313      byte[40]       array of triangle colors
addr.colorbits = 322
DIM colorbits(39) AS STRING * 1
'353      byte[30]       array of indices (shadow)
addr.indxshad = 362
DIM indxshad(9, 2) AS STRING * 1
'383      byte           unused
'384      vec3[30]       array of vertices
addr.vert = 393
DIM vert(29, 2) AS SINGLE
'744      vec3[30]       array of normals
addr.normal = 753
DIM normal(29, 2) AS SINGLE
'1104     vec3[15]       array of vertices (shadow)
addr.vertshad = 1113
DIM vertshad(14, 2) AS SINGLE
'1284     vec3[4]        array of tyre positions (RF, LF, RR, LR)
addr.tire = 1293
DIM tire(3, 2) AS SINGLE
'1332     vec3           helmet position
addr.helmet = 1341
DIM helmet(2) AS SINGLE

DIM surface(13) AS STRING
surface(0) = "oil"
surface(1) = "tarmac"
surface(2) = "tarmac2"
surface(3) = "grass"
surface(4) = "mud"
surface(5) = "gravel"
surface(6) = "gravel2"
surface(7) = "sand"
surface(8) = "sand2"
surface(9) = "snow"
surface(10) = "ice"
surface(11) = "kerb"
surface(12) = "kerb2"
surface(13) = "loose gravel"

DIM z AS STRING * 1

'************  end of data definitions ********************

DIM SHARED vertexnum AS INTEGER
DIM SHARED polynum AS INTEGER
vertexnum = 0
polynum = 0
CLS
    INPUT "Name of Shadow 3DO TXT file? ", f1$
    OPEN f1$ FOR INPUT AS #1
    INPUT "Name of Car file? ", f2$
    OPEN f2$ FOR BINARY AS #2
    DO WHILE NOT EOF(1)
        INPUT #1, v1$
        IF v1$ = "p" THEN
            CALL vertex
        END IF
        IF v1$ = "v" THEN
            CALL poly
        END IF
    LOOP
    PRINT polynum, vertexnum
    polynum = polynum * 3
    z = CHR$(polynum)
    PUT #2, addr.numindxshad, z
    vertexnum = vertexnum
    z = CHR$(vertexnum)
    PUT #2, addr.numvertshad, z
    CLOSE
    SYSTEM

    SUB poly
    '353      byte[30]       array of indices (shadow)
    addr.indxshad = 362
    DIM x AS STRING * 1
    DIM polys(2) AS STRING
    DIM polyval(2) AS SINGLE
        INPUT #1, p$
        IF VAL(p$) = -1 THEN
            EXIT SUB
        END IF
        INPUT #1, p$
        FOR i = 0 TO 2
            INPUT #1, polys(i)
            polyval(i) = VAL(polys(i))
            x = CHR$(polyval(i))
            PUT #2, addr.indxshad + i + polynum * 3, x
        NEXT
        PRINT polynum, polyval(0), polyval(1), polyval(2)
        polynum = polynum + 1
    END SUB

    SUB vertex
    '1104     vec3[15]       array of vertices (shadow)
    addr.vertshad = 1113
    DIM vert(29, 2) AS SINGLE
    DIM vertexs(2) AS STRING
    DIM vertexval(2) AS SINGLE
        FOR i = 0 TO 2
            INPUT #1, vertexs(i)
            vertexval(i) = VAL(vertexs(i))
            PUT #2, addr.vertshad + i * 4 + vertexnum * 12, vertexval(i)
        NEXT
        PRINT vertexnum, vertexval(0), vertexval(1), vertexval(2)
        vertexnum = vertexnum + 1
    END SUB

